package javato.activetesting.coverage ;

import java.io.* ;
import java.util.* ;

/**
 * Copyright (c) 2007-2008,
 * Koushik Sen    <ksen@cs.berkeley.edu>
 * All rights reserved.
 * <p/>
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * <p/>
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * <p/>
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * <p/>
 * 3. The names of the contributors may not be used to endorse or promote
 * products derived from this software without specific prior written
 * permission.
 * <p/>
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


public class MyEvent implements Serializable {
	public static int START = 0 ;
	public static int CREATE = 1 ;
	public static int JOIN = 2 ;	
	public static int LOCK = 3 ;
	public static int UNLOCK = 4  ;
	public static int WAIT = 5 ;
	public static int NOTIFY = 6 ;
	public static int NOTIFYALL = 7 ;
	
	public int type ;
	public Integer iid ;
	public Integer par ; 

	public MyEvent(int type, Integer iid, Integer par) {
		this.type = type ;
		this.iid = iid ;
		this.par = par ;
	}

	public boolean equals(Object object) {
		if (object == null)
			return false ;
		if (!(object instanceof MyEvent))
			return false ;
		MyEvent e = (MyEvent) object ;
		return (this.type == e.type 
			&& this.iid.intValue() == e.iid.intValue() 
			&& this.par.intValue() == e.par.intValue()) ;
	}

	public String toString() {
		/*
		return "[" + type + "," + iid + "," + par + "]" ;
		*/
		String r = new String("[") ;
		switch (type) {
			case 0 :
				r += "Start" ;
				break ;
			case 1 :
				r += "Create" ;
				break ;
			case 2 :
				r += "Join" ;
				break ;
			case 3 :
				r += "Lock" ;
				break ;
			case 4 :
				r += "Unlock" ;
				break ;
			case 5 :
				r += "Wait" ;
				break ;
			case 6 :
				r += "Notify" ;
			 	break ;
			case 7 :
				r += "NotifyAll" ;
				break ;				
		}
		r += "(" + iid + "," + par + ")" ;
		r += "]" ;
		return r ;
	}
}
